当今需要安装 Linux 的五大理由
===========================

如果你在阅读本文，那么你可能是一个 Linux 新手或者是 Linux 的潜在用户。又或者我猜的都不对，你只是好奇于我所说的当今需要安装 Linux 的五大理由。

不管如何，我都欢迎你来看看我做出的解释。如果说你能够读完全文，记得使用下边的评论功能分享你的想法。

**建议阅读：** [关于 GNU/Linux，我所喜恶的五件事][1]

**声明**：以下列出的理由并非按照重要性顺序排列。也就是说，你可以从上到下或者以你愿意的顺序来进行阅读。

### 理由 1 – Linux 自由、免费

在 Linux 这个生态系统中，**“自由、免费 (free)”** 有两种含义：**1) 自由使用（Free as in freedom）** 以及 **2) 免费使用（Free as in beer）**。

第一个含义意味着，你可以自由使用 Linux 做你想要的任何事，比如个人使用或者商业用途。

第二个含义表明这样一个事实，多数 (**99%**) 的 Linux 发行版 (或者说，不同风格的 Linux) 都可以免费的下载和运行在大多数电脑上。

**建议阅读：** [2016 年最流行的 Linux 发行版][2]

商业发行版经常应用到企业环境，以便获取其后公司的技术支持。红帽公司著名的 [红帽企业级 Linux][3] 就是这样一个例子。

[![Linux 自由、免费](http://www.tecmint.com/wp-content/uploads/2017/01/Linux-is-Free.png)][4]

*Linux 自由、免费*

### 理由 2 – Linux 可以使老旧设备起死回生

是的，你没看错。如果你有一部老旧电脑已经积满灰尘，因为它已经无法满足其他操作系统的硬件要求，那么 Linux 可以帮你拯救它。以我的经验来说，我第一台电脑 (2000 年末，我母亲给我的高中毕业礼物) 作为家庭服务器已经连续运行 5 年了 —— 一直在使用 Debian 最新的稳定版。

**建议阅读：** [老旧电脑和笔记本值得尝试的 6 个 Linux 发行版][5]

[![Linux 支持老旧设备](http://www.tecmint.com/wp-content/uploads/2017/01/Linux-Supports-Old-Hardware.jpg)][6]

*Linux 支持老旧设备*

### 理由 3 – Linux 是学习计算机如何工作的最好工具

即使是新手，访问并与电脑硬件进行交互也是相对容易的。通过诸如 [dmesg][8] （从内核中列出相关信息）等 [命令行工具][7]加上一点耐心，你可以很容易了解从你按下电源开关到加载好一个完整可用的系统到底发生了哪些事情。当然，这只是其中一个例子。

[![学习 Linux](http://www.tecmint.com/wp-content/uploads/2017/01/Learn-Linux.jpg)][9]

*学习 Linux*

### 理由 4 – Linux 是学习编程的最好工具

我常常说，要是我早些认识 Linux 该多好。安装好系统之后，它就具备了开始学习 [Python 编程][10] 的必备工具。作为当今最流行的面向对象的编程语言之一，Python 在多所顶尖大学里都是计算机科学专业的主修课程。

[![学习 Linux 及 Python 编程](http://www.tecmint.com/wp-content/uploads/2017/01/Learn-Linux-with-Python-Programming.png)][11]

*学习 Linux 及 Python 编程*

### 理由 5 – 大量自由的世界一流软件

当然，我知道这与 **理由 1** 多少有些相似，但我还是决定将其列为一个独立的理由。为何？因为这为我们强调了这样一个事实，我们今天所使用的软件大多数是来自于大量志愿者的努力。

是的，写出这些优秀软件的人员从中不挣一分钱。在某些情况下，也有些公司为软件的开发和维护提供资金。

**建议阅读：** [2015 年我找到的 20 款自由开源的软件][12]

Linux 系统是相当稳定的，所以他们都想要将他们的软件运行其中。这就是为什么很多公司愿意为 Linux 生态系统做出大量贡献的原因 (指捐赠或者提供人力)。

[![自由开源软件](http://www.tecmint.com/wp-content/uploads/2017/01/Free-Open-Source-Software.jpg)][13]

*自由开源软件*

### 总结

感谢你花费时间来阅读本文！关于我会第一时间建议他人使用的 Linux 的理由，我已经尽最大努力来阐述了。

如果你有不同于本文的意见，欢迎随时使用下方评论表单来分享您的观点。

------------------------------------

作者简介：

Gabriel Cánepa - 一位来自阿根廷圣路易斯梅塞德斯镇 (Villa Mercedes, San Luis, Argentina) 的 GNU/Linux 系统管理员，Web 开发者。就职于一家世界领先级的消费品公司，乐于在每天的工作中能使用 FOSS 工具来提高生产力。

------------------------------------

译者简介：

[GHLandy](http://GHLandy.com) —— 划不完粉腮柳眉泣别离。

------------------------------------

via: http://www.tecmint.com/install-linux-today/

作者：[Gabriel Cánepa][a]
译者：[GHLandy](https://github.com/GHLandy)
校对：[jasminepeng](https://github.com/jasminepeng)

本文由 [LCTT](https://github.com/LCTT/TranslateProject) 原创编译，[Linux中国](https://linux.cn/) 荣誉推出

[a]:http://www.tecmint.com/install-linux-today/
[1]:http://www.tecmint.com/things-i-dislike-and-love-about-gnu-linux/
[2]:http://www.tecmint.com/top-best-linux-distributions-2016/
[3]:http://www.tecmint.com/red-hat-rhcsa-rhce-exam-certification-book/
[4]:http://www.tecmint.com/wp-content/uploads/2017/01/Linux-is-Free.png
[5]:http://www.tecmint.com/linux-distributions-for-old-computers/
[6]:http://www.tecmint.com/wp-content/uploads/2017/01/Linux-Supports-Old-Hardware.jpg
[7]:http://www.tecmint.com/category/linux-commands/
[8]:http://www.tecmint.com/dmesg-commands/
[9]:http://www.tecmint.com/wp-content/uploads/2017/01/Learn-Linux.jpg
[10]:http://www.tecmint.com/category/python/
[11]:http://www.tecmint.com/wp-content/uploads/2017/01/Learn-Linux-with-Python-Programming.png
[12]:http://www.tecmint.com/best-free-open-source-softwares-of-2015/
[13]:http://www.tecmint.com/wp-content/uploads/2017/01/Free-Open-Source-Software.jpg
